//+------------------------------------------------------------------+
//|                                                          EqV.mq4 |
//|                                                  Vadim Shumiloff |
//|                                                shumiloff@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Vadim Shumiloff"
#property link      "shumiloff@mail.ru"

#property indicator_chart_window
#property indicator_color1 Yellow
#property indicator_color2 SteelBlue
#property indicator_buffers 2

extern int eVolume=100;
extern int eHistory=1000;

double Chart1[];
double Chart2[];
static datetime mTime;

int init()
  {
   IndicatorBuffers(2);
   
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);

   SetIndexBuffer(0, Chart1);
   SetIndexBuffer(1, Chart2);

   IndicatorShortName(StringConcatenate("EqV (", eVolume, ")"));
   SetIndexLabel(0, NULL);
   SetIndexLabel(1, NULL);

   mTime = iTime(NULL, PERIOD_M1, 0);
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   //         , 
   if (mTime == iTime(NULL, PERIOD_M1, 0)) return (0);
   //     
   mTime = iTime(NULL, PERIOD_M1, 0);
   
   //   
   int limit, i, j;
   int counted_bars = IndicatorCounted();
   if (counted_bars>0) counted_bars--;
   
   limit = iBars(NULL, PERIOD_M1);
   
   int mV;
   int eLimit = eVolume * eHistory;
   double mOpen, mClose, x, dx;
   double Tick[100000, 2], eOpen[1000], eClose[1000], eHigh[1000], eLow[1000];

   int eCounter = 0;
   int eBars = 0;
   
   //   
   for(i=0; i < limit; i++)
   {
     mV = iVolume(NULL, PERIOD_M1, i);   
     mOpen = iOpen(NULL, PERIOD_M1, i);   
     mClose = iClose(NULL, PERIOD_M1, i);
     
     //     
     for (j=0; j < mV; j++)
     {
       dx = (mClose - mOpen) / mV;
       Tick[eCounter, 0] = NormalizeDouble(mOpen + dx*j, 4);
       Tick[eCounter, 1] = NormalizeDouble(mClose + dx*j, 4);
       eCounter++;
     }
     if (eCounter > eLimit) break;
   }

   //   eBar-
   for (i=0; i < eHistory; i++)
   {
      //          
      eOpen[i] = Tick[i*eVolume, 0];
      //          
      eClose[i] = Tick[(i+1)*eVolume-1, 1];
      
      //            
      eHigh[i] = 0;
      eLow[i] = 9999999;
      
      for (j = 0; j < eVolume; j++)
      {
         int tmp = i*eVolume+j;
         if (eHigh[i] < Tick[tmp, 0]) eHigh[i] = Tick[tmp, 0];
         if (eHigh[i] < Tick[tmp, 1]) eHigh[i] = Tick[tmp, 1];
         if (eLow[i]  > Tick[tmp, 0])  eLow[i] = Tick[tmp, 0];
         if (eLow[i]  > Tick[tmp, 1])  eLow[i] = Tick[tmp, 1];
      }
   }

   //  
   for(i=0; i < limit; i++)
   {
      Chart1[i] = (eHigh[i] + eLow[i] + eClose[i]) / 3;
      Chart2[i] = (High[i] + Low[i] + Close[i]) / 3;
   }
   
   return(0);
}


